<?php
/*
* Plugin Name: wpForo - Image to Image Link Converter
* Plugin URI: http://wpforo.com
* Description: Converts images to image links
* Version: 1.0.0
* Author: gVectors Team
* Author URI: http://gvectors.com/
*/

add_action('admin_menu', 'wpfbody_add_menu');
function wpfbody_add_menu(){
    add_menu_page('do replace', 'wpForo Img2Link', 'administrator', 'wpforo-body-replacer', 'wpfbody_body_replacer');
}

function wpfbody_body_replacer(){
    echo '<center>
        <a onclick="return confirm(\'IMPORTANT! Do not run this process twice, just click [cancel] on second time\')" href="'.admin_url('admin.php?page=wpforo-body-replacer&action=do').'"><h1 style="color: green">[Start Conversion]</h1></a>
        ';
        if( isset($_GET['status']) && $_GET['status'] == 'ok' ){
            echo '<span style="color: green">Successfully replaced</span>';
        }elseif(isset($_GET['status']) && $_GET['status'] == 'ko'){
            echo '<span style="color: orange">No row affected</span>';
        }
    echo '</center>';
}

add_action('wp_loaded', 'wpfbody_do_actions');
function wpfbody_do_actions(){
    if( isset($_GET['page']) && $_GET['page'] == 'wpforo-body-replacer' && isset($_GET['action']) && $_GET['action'] == 'do' ){
        global $wpdb;

        $s = false;

        $sql = "select postid, body from " . $wpdb->prefix . "wpforo_posts where body like '%<img%'";
        if( $posts = $wpdb->get_results($sql, ARRAY_A) ){
            foreach ($posts as $post){
                $body = preg_replace('#(<img[^<>]*?src=[\"\']([^\"\']+?)[\"\'][^<>]*?>)#isu', '<a href="$2">$1</a>', $post['body']);

                $s = $wpdb->update(
                    $wpdb->prefix . "wpforo_posts",
                    array('body' => $body),
                    array('postid' => $post['postid']),
                    array('%s'),
                    array('%d')
                );
            }

        }

        wp_redirect(admin_url('admin.php?page=wpforo-body-replacer' . ($s ? '&status=ok' : '&status=ko') ));
        exit();
    }
}